// MultiUser Demo Application for xGenRecordID Package  1998, Deks.
// Read HELP before using application.
unit uxMainMultiUserDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, DBGrids, Db, DBTables, uxGenRecordID;

type
  TxFormMultiUSerDemo = class(TForm)
    PanelErrorLog: TPanel;
    ErrorLog: TMemo;
    PanelAddLog: TPanel;
    AddLog: TMemo;
    Table: TTable;
    DataSource: TDataSource;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    ButtonStart: TButton;
    ButtonStop: TButton;
    xGenRecordID: TxGenRecordID;
    ButtonEmpty: TButton;
    ButtonRefresh: TButton;
    InstanceName: TEdit;
    TableID: TIntegerField;
    TableCaption: TStringField;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    procedure ButtonStartClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure ButtonEmptyClick(Sender: TObject);
    procedure ButtonRefreshClick(Sender: TObject);
  private
  public
    StopFlag: Boolean;
  end;

var
  xFormMultiUSerDemo: TxFormMultiUSerDemo;

implementation

{$R *.DFM}

// ----------------------------------------------------------------------------
procedure TxFormMultiUSerDemo.ButtonStartClick(Sender: TObject);
begin
  // Procedure to Add records to table.
  
  // clear error logs:
  AddLog.Lines.Clear;
  ErrorLog.Lines.Clear;

  // enable/disable controls:
  ButtonStart.Enabled := False;
  ButtonStop.Enabled := True;
  ButtonEmpty.Enabled := False;
  ButtonRefresh.Enabled := False;
  InstanceName.Enabled := False;
  
  // start loop to add records:
  try
    StopFlag := False;
    while not StopFlag do begin
      // add new record to table:
      Table.Append;
      Table.FieldByName('Caption').AsString := 'record '+
        Table.FieldByName('ID').AsString +
        ' (' + InstanceName.Text + ')';
      try
        // try to post new record to Table:
        Table.Post;

        // log success for adding record (mention instance name in log):
        AddLog.Lines.Add('ID='+Table.FieldByName('ID').AsString +
          ' (' + InstanceName.Text + ')');
      except
        // Yeah! Error! Log it!
        ErrorLog.Lines.Add('Error for ID='+Table.FieldByName('ID').AsString);

        // try to get another ID from Table:
        Table.FieldByName('ID').AsInteger := xGenRecordID.GenerateID;

        // try to post again:
        try Table.Post;
        except
          // again we get an error!
          ErrorLog.Lines.Add('Another error for ID='+
            Table.FieldByName('ID').AsString);
          // generate new ID second time:
          Table.FieldByName('ID').AsInteger := xGenRecordID.GenerateID;

          // try to post second time:
          try
            Table.Post;
          except
            // oh-no! again we get an error - it's LAST time!
            ErrorLog.Lines.Add('Too bad ! Second error for ID='+
              Table.FieldByName('ID').AsString);
          end;
        end;
      end;

      // test for StopFlag status:
      Application.ProcessMessages;
    end; // while

  finally
    // resore StatusQuo for buttons :)
    ButtonStart.Enabled := True;
    ButtonStop.Enabled := False;
    ButtonEmpty.Enabled := True;
    ButtonRefresh.Enabled := True;
    InstanceName.Enabled := True;
  end;
end;

// ----------------------------------------------------------------------------
procedure TxFormMultiUSerDemo.ButtonStopClick(Sender: TObject);
begin
  // Set StopFlag to True:
  StopFlag := True;
end;

// ----------------------------------------------------------------------------
procedure TxFormMultiUSerDemo.ButtonEmptyClick(Sender: TObject);
var aQuery: TQuery;
begin
  // Try to empty table via query:
  aQuery := TQuery.Create(Self);
  aQuery.DatabaseName := Table.DatabaseName;
  aQuery.SQL.Add('delete from MultiUserDemo');
  try
    aQuery.ExecSQL;
  finally
    aQuery.Free;
  end;

  // refresh data:
  Table.Close;
  Table.Open;
end;

// ----------------------------------------------------------------------------
procedure TxFormMultiUSerDemo.ButtonRefreshClick(Sender: TObject);
begin
  // refresh displayed data:
  Table.Close;
  Table.Open;
  Table.Last;
end;



end.
