// xGenRecordID Package  1998, Deks
// Version info in readme.txt and help
//
// Deks Site: http://deks.webjump.com/
// E-mail: Deks@online.nsk.su
// ============================================================================
// Installation and design-time routines for component package.
unit uxGenRecordIDReg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, TypInfo, DsgnIntf, uxGenRecordID;

procedure Register;

implementation

uses DB, DBTables, uxAboutGenRecordIDForm;

// ============================================================================
type
  TxGenRecordIDEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure TxGenRecordIDEditor.ExecuteVerb(Index: Integer);
begin
  // Show "about form".
  with TxAboutGenRecordIDForm.Create(Application) do begin
    try
      ShowModal;
    finally
      Free;
    end;
  end;
end;

function TxGenRecordIDEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'xGenRecordID Package v1.3';
    1: Result := ' 1998, Deks';
  end;
end;

function TxGenRecordIDEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

// ============================================================================
type
  TxDBStringProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings); virtual;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

function TxDBStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TxDBStringProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

procedure TxDBStringProperty.GetValueList(List: TStrings);
begin
end;

// ============================================================================
type
  TxTableNameProperty = class(TxDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

procedure TxTableNameProperty.GetValueList(List: TStrings);
begin
  if not (GetComponent(0) is TxGenRecordID) then Exit;
  if (GetComponent(0) as TxGenRecordID).DataSet = nil then Exit;
    
  (GetComponent(0) as TxGenRecordID).DataSet.DBSession.GetTableNames((GetComponent(0)
    as TxGenRecordID).DataSet.DatabaseName, '', True, False, List);
end;

// ============================================================================
type
  TxFieldProperty = class(TxDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
    function GetDataSourcePropName: string; virtual;
  end;

function TxFieldProperty.GetDataSourcePropName: string;
begin
  Result := 'DataSet';
end;

procedure TxFieldProperty.GetValueList(List: TStrings);
var
  Instance: TComponent;
  PropInfo: PPropInfo;
  DataSource: TDBDataSet;
begin
  Instance := TComponent(GetComponent(0));
  PropInfo := TypInfo.GetPropInfo(Instance.ClassInfo, GetDataSourcePropName);
  if (PropInfo <> nil) and (PropInfo^.PropType^.Kind = tkClass) then
  begin
    DataSource := TObject(GetOrdProp(Instance, PropInfo)) as TDBDataSet;
    if (DataSource <> nil)  then
      DataSource.GetFieldNames(List);
  end;
end;

// ============================================================================
procedure Register;
begin
  RegisterComponents('Data Controls', [TxGenRecordID]);
  RegisterNonActiveX([TxGenRecordID], axrComponentOnly);
  RegisterPropertyEditor(TypeInfo(TxFieldName), TxGenRecordID, 'KeyField', TxFieldProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TxGenRecordID, 'TableName', TxTableNameProperty);
  RegisterComponentEditor(TxGenRecordID,TxGenRecordIDEditor);  
end;

end.
